// T11simReg2.sce
// STATIC REGRESSION MODEL WITH KNOWM VARIANCE
// Experiments
// - change constant kS of the model
// - change the input signal and check quality of estimation
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

// PARAMETERS                                                           // 1
nd=100;                       // length of data                         // 2
kS=5;                         // constant (model absolute term)         // 3
sS=.1;                        // noise std                              // 4
u=signal(nd,1,.1);            // input                                  // 5
S=0; ka=0;                    // initial statistics (zero information)  // 6
                                                                        // 7
// TIME LOOP                                                            // 8
for t=1:nd                                                              // 9
  // simulation                                                         // 10
  y(t)=kS+sS*rand(1,1,'n');   // simulation                             // 11
  // update                                                             // 12
  S=S+y(t);                   // statistics update                      // 13
  ka=ka+1;                                                              // 14
  // parameters                                                         // 15
  kE=S/ka;                    // estimate (average)                     // 16
  tht(t)=kE;                                                            // 17
end                                                                     // 18
                                                                        // 19
// RESULTS OF THE SIMULATION                                            // 20
set(gcf(),"position",[500 100 1200 400])                                // 21
subplot(131),plot(1:nd,u),title('Input')                                // 22
subplot(132),plot(1:nd,y),title('Output')                               // 23
subplot(133),plot(1:nd,tht),title('Evolution of pt.estimates')          // 24
disp('Sinulated values of k',kS)                                        // 25
disp('Final estimate of k',kE)                                          // 26
