// T12modExp.sce
// SIMULATION OF EXPONENTIAL MODEL  f(y)=a*exp(-a*y)
// Experiments
// - change parameters of the model
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

// PARAMETERS AND INITIAL STATISTICS                                    // 1
nd=1000;                      // length of data                         // 2
aS=.4;                        // model parameter                        // 3
                                                                        // 4
S=0; ka=0;                    // initial statistics                     // 5
// TIME LOOP                                                            // 6
for t=1:nd                                                              // 7
  // simulation                                                         // 8
  y(t)=-log(rand(1,1,'u'))/aS;                                          // 9
                                                                        // 10
  // estimation                                                         // 11
  S=S+y(t);                                                             // 12
  ka=ka+1;                                                              // 13
end                                                                     // 14
aE=ka/S;                                                                // 15
                                                                        // 16
// RESULTS                                                              // 17
disp('Estimate of aS',aE)                                               // 18
                                                                        // 19
set(scf(),'position',[600 100 600 400]);                                // 20
histplot(20,y);                                                         // 21
title 'Histogram of generated values'                                   // 22
