// T13modRay.sce
// SIMULATION OF RAYLEIGH MODEL  f(y)=f(y)=(y/r)*exp(-y**2/(2r))
// Experiments
// - change parameter of the model
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

nd=1000;                                                                // 1
rS=40;                              // parameter                        // 2
                                                                        // 3
// SIMULATION                                                           // 4
y=zeros(1,nd);                                                          // 5
// loop of simulation                                                   // 6
for t=1:nd                                                              // 7
  y(:,t)=sqrt(-2*rS.*log(rand(1,1,'u')));                               // 8
end                                                                     // 9
                                                                        // 10
// INITIALIZATION                                                       // 11
S=0;                               // statistics - sum                  // 12
ka=0;                              // statistics - counter              // 13
                                                                        // 14
// ESTIMATION                                                           // 15
// loop of estimation                                                   // 16
for t=1:nd                                                              // 17
  S=S+y(t)^2;                      // update of statistics              // 18
  ka=ka+1;                                                              // 19
end                                                                     // 20
rE=.5*S/ka;                        // final point estimates             // 21
                                                                        // 22
// RESULTS                                                              // 23
disp('Estimate of the parameter r',rE)                                  // 24
                                                                        // 25
set(scf(),'position',[600 100 600 400]);                                // 26
histplot(20,y);                                                         // 27
title 'Histogram of generated values'                                   // 28
