// T15modBin1.sce
// ESTIMATION OF MODIFIED BINOMIAL MODEL 
// Experiments
// - change parameters of the model
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

nd=1000;                                // number of data               // 1
p=.8; N=10;                             // pars of modif.binomial dist. // 2
                                                                        // 3
// SIMULATION                                                           // 4
for t=1:nd                                                              // 5
  x(t)=sampBin1(p,N);                   // generation                   // 6
end                                                                     // 7
                                                                        // 8
S=80; ka=10;                            // prior information            // 9
// ESTIMATION                                                           // 10
for t=1:nd                                                              // 11
  S=S+x(t);                             // update of statistics         // 12
  ka=ka+1;                                                              // 13
  pE(t)=(S-ka)/((N-1)*ka);              // estimates of parameters      // 14
end                                                                     // 15
                                                                        // 16
// RESULTS                                                              // 17
plot(pE)                                                                // 18
plot([nd/2 nd],[p p],':r')                                              // 19
xlabel('time')                                                          // 20
ylabel('estimates')                                                     // 21
title('Time evolution of the estimated parameter')                      // 22
legend('estimats','true value');                                        // 23
