// T21preReg.sce
// ZERO-STEP PREDICTION WITH REGRESSION MODEL
// - unknown parameters
// Experiments
// - change parameters of the model
// - change the input signal
// - change initial statistics
// - try to increase the model order to 3
// - show evolution of the parametrs estimates
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

// PARAMETERS AND INITIAL STATISTICS                                    // 1
nd=1000;                                     // length of data          // 2
b0S=1; a1S=.4; b1S=.2; kS=-1; rS=.1;         // model parameter         // 3
thS=[b0S a1S b1S kS]';                                                  // 4
u=signal(nd);                                // definition of input     // 5
V=1e-5*eye(5,5);                             // initial statistics      // 6
ka=0; y=0;                                   // initial ka and y        // 7
b0E=0; a1E=0; b1E=0; kE=0;                   // initial parameters      // 8
                                                                        // 9
// TIME LOOP                                                            // 10
for t=2:nd                                                              // 11
  // prediction                                                         // 12
  yp(t)=b0E*u(t)+a1E*y(t-1)+b1E*u(t-1)+kE;                              // 13
                                                                        // 14
  // simulation                                                         // 15
  y(t)=b0S*u(t)+a1S*y(t-1)+b1S*u(t-1)+kS+sqrt(rS)*rand(1,1,'n');        // 16
                                             // simulation              // 17
                                                                        // 18
  // estimation                                                         // 19
  Ps=[y(t) u(t) y(t-1) u(t-1) 1]';           // ext. regression vector  // 20
  V=V+Ps*Ps';                                // update of statistics    // 21
  ka=ka+1;                                   // update of statistics    // 22
  Vy=V(1,1); Vyp=V(2:$,1); Vp=V(2:$,2:$);    // division of inf.matrix  // 23
  thE=inv(Vp)*Vyp;                           // point regr.coefficients // 24
  rE=(Vy-Vyp'*thE)/ka;                       // point mosel variance    // 25
  b0E=thE(1); a1E=thE(2); b1E=thE(3); kE=thE(4);                        // 26
end                                                                     // 27
                                                                        // 28
// RESULTS                                                              // 29
disp('Simulated thS',thS)                                               // 30
disp('Estimate thE',thE)                                                // 31
                                                                        // 32
set(scf(),'position',[600 100 600 400]);                                // 33
plot(1:nd,y,1:nd,yp);                                                   // 34    
title 'Output and its prediction'                                       // 35
                                                                        // 36
RPE=rpe(y,yp);                                                          // 37
disp('Relative prediction error',RPE)                                   // 38
