// T22preExp.sce
// PREDICTION WITH EXPONENTIAL MODEL
// with unknown parameters
// Experiments
// - change parameters of the model
// - change the input signal
// - change initial statistics
// - try to increase the model order to 3
// - show evolution of the parametrs estimates
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), mode(0)

// PARAMETERS AND INITIAL STATISTICS                                    // 1
nd=200;                                      // length of data          // 2           
aS=4;                                        // model parameter         // 3
S=1/10;                                      // initial statistics      // 4
ka=1;                                        // initial statistics      // 5
aE=ka/S;                                     // initial parameter       // 6
                                                                        // 7
// TIME LOOP                                                            // 8
for t=2:nd                                                              // 9
  // prediction                                                         // 10
  yp(t)=-log(rand(1,1,'u'))/aE;              // prediction of y         // 11
                                                                        // 12
  // simulation                                                         // 13
  y(t)=-log(rand(1,1,'u'))/aS;               // simulation of y         // 14
                                                                        // 15
  // estimation                                                         // 16
  S=S+y(t);                                  // update of               // 17
  ka=ka+1;                                   //   statistics            // 18
  aE=ka/S;                                   // estimate of par.        // 19
end                                                                     // 20
                                                                        // 21
// RESULTS                                                              // 22
disp('Simulated aS',aS)                                                 // 23
disp('Estimate aE',aE)                                                  // 24
                                                                        // 25
set(scf(),'position',[600 100 600 400]);                                // 26
plot(1:nd,y,1:nd,yp);                                                   // 27    
title 'Output and its prediction'                                       // 28
                                                                        // 29
RPE=rpe(y,yp);                                                          // 30
disp('Relative prediction error',RPE)                                   // 31
