// T31stEstNois.sce
// KALMAN AS A NOISE FILTER
// Experiments
// - change Rw and Rv to catch properly the signal
// - Rw ... changes of the signal
// - Rv ... changes of the noise
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), 
getd(), mode(0)

// SIMULATION                                                           // 1
tt=0:.1:(2*%pi);                                                        // 2
nt=length(tt);                                                          // 3
sd=2;                                   // simulation noise             // 4
e=[sd*rand(1,nt,'n'); sd*rand(1,nt,'n')];                               // 5
g=[10*cos(tt); 15*sin(tt)];             // pure signal (ellipse)        // 6
x=g+e;                                  // measured noisy signal        // 7
                                                                        // 8
// FILTRATION                                                           // 9
Rz=1e6*eye(2,2);                        // state-estimate cov. matrix   // 10
Rw=0.01*eye(2,2);                       // state-model cov. matrix      // 11
Rv=.1*eye(2,2);                         // output-model cov. matrix     // 12
M=[1 0                                  // state-model matrices         // 13
   0 1];                                                                // 14
A=[1 0                                                                  // 15
   0 1];                                                                // 16
N=[0 0]';                                                               // 17
F=[0 0]';                                                               // 18
B=0;                                                                    // 19
G=0;                                                                    // 20
z(:,1)=[0 0]';                          // initial state                // 21
                                                                        // 22
for t=2:nt                                                              // 23
  [z(:,t),Rz,yp]=Kalman(z(:,t-1),x(:,t),0,M,N,F,A,B,G,Rw,Rv,Rz);        // 24
end                                                                     // 25
                                                                        // 26
// Results                                                              // 27
//plot(g(1,:),g(2,:),'k:')                                              // 28
plot(x(1,:),x(2,:),'b.')                                                // 29
plot(z(1,:),z(2,:),'r.:')                                               // 30
legend('signal','measurements','estimate');                             // 31
