// T32stEstPar.sce
// STATE ESTIMATION WITH MODEL WITH UNKNOWN PARAMETRS
// Experiments
// - change rwE and rvE to improve results
// - rwE ... changes of the signal
// - rvE ... changes of the noise
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), 
getd(), mode(0)

nd=100;                                                                 // 1
// PARAMETERS                                                           // 2
aS=.6;                                                                  // 3
bS=2;                                                                   // 4
x=0;                                                                    // 5
rwS=.1;                                                                 // 6
rvS=.1;                                                                 // 7
u=signal(nd,1,1);                                                       // 8
                                                                        // 9
// SIMULATION                                                           // 10
for t=2:nd                                                              // 11
  x(t)=aS*x(t-1)+u(t)+rwS*randn();                                      // 12
  y(t)=bS*x(t)+rvS*randn();                                             // 13
end                                                                     // 14
                                                                        // 15
// ESTIMATION                                                           // 16
// initialization                                                       // 17
xE=zeros(3,1); xE(2)=aS; xE(3)=bS;                                      // 18
rwE=.01*eye(3,3); rwE(1,1)=rwS;                                         // 19
rvE=rvS;                                                                // 20
rxE=1000*eye(3,3);                                                      // 21
// time loop                                                            // 22
for t=2:nd                                                              // 23
  M=[xE(2) xE(1) 0; 0 1 0; 0 0 1];                                      // 24
  F=[xE(2)*xE(1)+u(t-1) xE(2) xE(3)]'-M*xE;                             // 25
  xp=M*xE+F;                                                            // 26
  A=[xp(3) 0 xp(1)];                                                    // 27
  G=xp(3)*xp(1);                                                        // 28
  [xE,rxE,yp] = Kalman(xE,y(t),u(t),M,[],F,A,[],G,rwE,rvE,rxE);         // 29
  xt(:,t)=xE;                                                           // 30
end                                                                     // 31
                                                                        // 32
// RESULTS                                                              // 33
set(scf(),'position',[500 100 1000 400])                                // 34
subplot(131),plot(xt(1,:))                                              // 35
subplot(132),plot(xt(2,:))                                              // 36
subplot(133),plot(xt(3,:))                                              // 37
