// T44mixDesExp.sce
// MIXTURE ESTIMATION (descriptive, exponential)
// - static componens
// Experiments
// - change simulated parameters
// - change initial parameters
// -------------------------------------------------------------------
exec("ScIntro.sce",-1), 
getd(), mode(0)

nd=500;                                                                 // 1
// PARAMETERS                                                           // 2
aS=[1 3 2 5];                           // simulated comp. expectations // 3
nc=length(aS);                          // number of components         // 4
alS=[.1 .2 .4 .3];                      // parameters of pointer model  // 5
                                                                        // 6
// SIMULATION                                                           // 7
for t=1:nd                                                              // 8
  jS=sampCat(alS);                      // pointer value                // 9        
  cS(t)=jS;                             // stor pointer value           // 10
  y(t)=-log(randu())/aS(jS);            // output                       // 11
end                                                                     // 12
                                                                        // 13
// ESTIMATION                                                           // 14
// initialization                                                       // 15
aE=[1 5 3 10];                                                          // 16
ka=[1 1 1 1];                           // initial counter              // 17   
S=ka./aE;                                                               // 18
                                                                        // 19
// time loop of estimation                                              // 20
th=aE;                                                                  // 21
for t=1:nd                                                              // 22
  for j=1:nc                                                            // 23
    q(j)=aE(j)*exp(-aE(j)*y(t));        // proximity                    // 24
  end                                                                   // 25
  w=q/sum(q);                           // weights                      // 26
  wt(:,t)=w;                            // remember weights             // 27
  for j=1:nc                                                            // 28
    S(j)=S(j)+w(j)*y(t);                // update of inf. matrix        // 29
    ka(j)=ka(j)+w(j);                   // update of counter            // 30   
    aE(j)=ka(j)/S(j);                   // point estimates              // 31   
  end                                                                   // 32
  th=[th; aE];                         // remember point estimates      // 33
end                                                                     // 34
                                                                        // 35
// RESULTS                                                              // 36
tx=['b';'r';'g';'k'];                                                   // 37
set(scf(1),'position',[600 10 600 400])   // evolution of par. est.     // 38             
for j=1:nc                                                              // 39
  plot(th(:,j),'-'+tx(j))                                               // 40
end                                                                     // 41
title 'Evolution of the estimated parameters'                           // 42
legend('c1','c2','c3','c4');                                            // 43
                                                                        // 44
disp 'The final parmeter estimates are'                                 // 45
disp(aE)                                                                // 46
                                                                        // 47
[nill,cp]=max(wt,'r');                    // accuracy of classification // 48
disp 'Accuracy of classification'                                       // 49
ACC=acc(cS,cp)                                                          // 50

