// Unif est - sim (Method of moments)
// - dDel  no
// - forg  no
// -------------------------------------------
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data
exec("ScIntro.sce",-1),mode(0)          // intro to sesion

// ==========================================================
frg=1;   // forgetting   yL=yL-frg/t
ptw=0;    // point w      ptw=1 - use point w
// ==========================================================

nd=500;                            // number of data 
// SIMULATION
thS=list();
alS=[.4 .3 .3];                    // alS
thS(1)=[1 4
        1 7];                      // thS
thS(2)=[3 11
        6 11];
thS(3)=[10 15
        10 15];
nc=length(alS);                    // numb. of components
ny=size(thS(1),1);                 // dimension of y
for t=1:nd
  c(t)=sampCat(alS);               // pointer generation
  for i=1:ny
    y(i,t)=randu()*(thS(c(t))(i,2)-thS(c(t))(i,1))+thS(c(t))(i,1);
  end                              // generation of y
end

// INITIALIZATION
S=list(); T=list(); C=list(); r=list(); 
thR=list(); thC=list(); D=list();
S(1)=[5; 2];                       // initial statistics (sums)
S(2)=[9; 4];                       // - centers of initial windows
S(3)=[12; 9];
for j=1:nc, C(j)=S(j); r(j)=.1*ones(ny,1); D(j)=diag(r(j)); end
                                   // ceneters, radiuses, covar.
ka=ones(1:nc);                     // counter
nc=length(S);                      // number of components 
nu=ones(1,nc);                     // pointer statistics
al=fnorm(nu);                      // pointer parameter
Lm=zeros(1,nc);
for j=1:nc
  thR(j)=zeros(ny,nd); thC(j)=zeros(ny,nd);
  T(j)=S(j)^2;
end  
thI=thCons(C,r);                   // initial windows
ir=0;                              // switch for estimation D

for t=2:nd   // ----------- TIME LOOP --------------
  // weights
  if t>15, ir=1; end               // D is estimated from t=15
  for j=1:nc
    V=ir*1e-2*D(j)+(1-ir)*.1*eye(ny,ny);    // cov. matrix
    [xxx,Lm(j)]=GaussN(y(:,t),C(j),V);
  end                              // Gaussian proximity
  Lm=Lm-max(Lm);
  m=exp(Lm);
  if sum(m)<1E-10, m=ones(1,nc); end // component is too far
  w=(m/sum(m));                    // weights
  if ptw==1, w=dDel(w); end        // point est. of pointer
  wt(:,t)=w'; 

  // on-line estimation - statistics
  for j=1:nc
    ka(j)=frg*ka(j)+w(j);          // counter
    S(j)=frg*S(j)+w(j)*y(:,t);     // sum
    T(j)=frg*T(j)+w(j)*y(:,t)^2;   // sum of squares
    C(j)=S(j)/ka(j);               // centers
    r(j)=sqrt(3*(T(j)/ka(j)-C(j)^2)); // radiuses
    for i=1:ny
      if r(j)(i)<1e-8, r(j)(i)=.01; end // correct zero length
    end
    D(j)=diag(r(j));               // cov. matrix for proximity
  end 

  // on-line estimation - parameters
  for j=1:nc
    thR(j)(:,t)=r(j);              // stor radiuses
    thC(j)(:,t)=C(j);              // stor centers
  end
  nu=nu+w;                         // pointer statistics
  al=fnorm(nu);                    // pointer parameter
end
th=thCons(C,r);                    //final windows

// RESULTS
cp=amax(wt,1);                     // estimates of components
Acc=acc(c,cp)                      // accuracy of classification

for j=1:nc
set(scf(),'position',[100+50*j 200+50*j 800 600])
  plot([thC(j)'])                  // evolution of centers
  title('Evolution of parameters - component '+string(j))
end

set(scf(),'position',[900 300 800 600]) // final windows
for j=1:nc
  plot(y(1,:),y(2,:),'c.')    // data
end  
unifplot(thI,'.:r')           // initial parameters
unifplot(th)                  // estimated parameters
ellips(D,C)                   // cuts of Gaussians for proximity
title 'Uniform clusters (red: initial support, blue: estimated support)'
