// expShift1ML.sce
// Odhad parametrů posunuté exponenciály 
//            y = a.exp(-a(x-b))
// -------------------------------------
clc, clear, close, mode(0)
exec SCIHOME/ScIntro.sce

nd=2000;

a=.8;
b=3;

// simulation
for t=1:nd
  y(t)=-log(rand(1,1,'u'))/a+b;
end

// estimation
s1=0;
s2=0;
for t=1:nd
  s1=s1+y(t);
  s2=s2+y(t)**2;
  sd=sqrt(s2/t-(s1/t)**2);
  b(t)=s1/t-sd;
  a(t)=1/(s1/t-b(t));
end

m=mean(y);
sd=stdev(y);

set(scf(),'position',[600 100 500 400])
plot([a b])

Ea=a($), Eb=b($)
