// ini5Opak.sce
// Opakovaný odhad na stejných datech
// ------------------------------------------
clc, clear, close(winsid()), mode(0)
[u,t,n]=file();                         // find working directory
chdir(dirname(n(2)));                   // set working directory
clear("u","t","n")                      // clear auxiliary data

nd=10;                                  // numb. of data
k=[2; -1]; sd=.01;                      // reg. parameters

for t=1:nd
  y(:,t)=k+sd*rand(2,1,'n');            // simulation
end

// Inicializace k prvnímu odhadu
kI=[-5;8];                              // initial parametrs
V0(1:2,1:2)=kI*kI'; 
V0(3,1:2)=kI'; V0(1:2,3)=kI; V0(3,3)=1; // initial inf. matrix
V0=V0*10; V=V0;                         // initial strength = 10

// První odhad
for t=1:nd
  Ps=[y(:,t)' 1]';
  V=V+Ps*Ps';
  Vy=V(1:2,1:2);
  Vyp=V(3:$,1:2);
  Vp=V(3:$,3:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;
  th1(:,t)=th';               // vývoj odhadů v první fázi
end
th1=[kI th1];                 // z výchozího odhadu kI se dále odhaduje

fi=50;     // Zkuste fi=1,10,50
V=V/fi;   // ZAPOMENUTÍ (uvolnění odhadu pro další postup) 
// Druhý odhad na stejných datech
for t=1:nd
  Ps=[y(:,t)' 1]';
  V=V+Ps*Ps';
  Vy=V(1:2,1:2);
  Vyp=V(3:$,1:2);
  Vp=V(3:$,3:$);
  th=inv(Vp+1e-12*eye(Vp))*Vyp;
  th2(:,t)=th';                     //  vývoj odhadů v druhé fázi
end

// Výsledky
scf();
plot(th1(1,:),th1(2,:),'.:')       // první odhad
plot(th2(1,:),th2(2,:),'.:g')      // druhý odhad
plot(2,-1,'ro','markersize',12)    // správná hodnota paramrtru k
set(gca(),'data_bounds',[-6 4 -2 9])
title 'Vývoj odhadu konstanty - b=1.odhad. g=2.odhad'  
